package costo.kml2java.monitor.gui.basecomponents;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import attic.TestPersonne;

public class GetSetField extends JPanel implements ActionListener, ChangeListener {

	public GetSetField(Method getter, Object baseObject) {
		super();
		this.getter = getter;
		this.setter = getSetter(baseObject, getter);
		this.baseObject = baseObject;
		this.name = new JLabel(getter.getName().substring(3));
		this.field = new JTextField(getStringValue());
		this.setLayout(new BoxLayout(this, BoxLayout.LINE_AXIS));
		if (setter != null) {
			this.ok = new JButton("ok");
			ok.addActionListener(this);
			this.add(ok);
		}
		this.add(name);
		this.add(field);

	}

	private Method getSetter(Object baseObject2, Method getter2) {
		String settername = "s" + getter2.getName().substring(1);
		Method thesetter = null;
		try {
			thesetter = baseObject2.getClass().getMethod(settername, getter2.getReturnType());
		} catch (SecurityException e) {

	//		e.printStackTrace();
		} catch (NoSuchMethodException e) {

		//	e.printStackTrace();
		}
		return thesetter;
	}

	public String getStringValue() {
		String value = "";
		try {
			value = getter.invoke(baseObject, null).toString();
		} catch (IllegalArgumentException e) {
		//	e.printStackTrace();
		} catch (IllegalAccessException e) {
		//	e.printStackTrace();
		} catch (InvocationTargetException e) {
		//	e.printStackTrace();
		}
		catch (Exception e) {
		//	System.err.println("PB getter"+ getter);
		//	e.printStackTrace();
		}
		return value;
	}

	public void setStringValue(String txt) {
		Object value = convertType(txt);
		try {
			setter.invoke(baseObject, value);
		} catch (IllegalArgumentException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		} catch (InvocationTargetException e) {
			e.printStackTrace();
		}

	}

	public Object convertType(String txt) {
		return txt;
	}

	private Method getter, setter;
	private Object baseObject;
	private JTextField field;
	private JButton ok;
	private JLabel name;

	@Override
	public void actionPerformed(ActionEvent arg0) {
		setStringValue(this.field.getText());

	}

	public static JPanel panels(Object o) {
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.Y_AXIS));

		for (Method m : o.getClass().getMethods()) {
			if (m.getName().startsWith("get")) {
				try {
					panel.add(new GetSetField(m, o));
				} catch (Exception e) {

				}
			}

		}
		return panel;
	}

	public static void main(String[] args) {
		JFrame test = new JFrame();

		test.add(panels(new TestPersonne("toto", 12, false)));
		test.pack();
		test.setVisible(true);
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		field.setText(getStringValue());
	}
}
