package costo.kml2java.monitor.gui.basecomponents;

import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Map;

import javax.swing.BoxLayout;
import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import costo.kml2java.framework.annotations.KmlElement;

public class StatePanel extends JPanel implements ChangeListener {
	Map<String, GetSetField> fields = new HashMap<String, GetSetField>();

	
	public StatePanel(Object o) {
		super();
		this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		createFields(o);
	}

	/**
	 * @param o
	 */
	private void createFields(Object o) {
		for (Method m : o.getClass().getMethods()) {
			if (m.getName().startsWith("get")&& m.getParameterTypes().length==0&&filterOk(m)) {
				try {

					GetSetField getSetField = new GetSetField(m, o);
					fields.put(m.getName().substring(3), getSetField);
					this.add(getSetField);
				} catch (Exception e) {
//e.printStackTrace();
				}
			}

		}
	}

	private boolean filterOk(Method m) {
//	System.out.println(m.getName()+ " "+m.getAnnotation(KmlElement.class));
		return m.getAnnotation(KmlElement.class)!=null;
	}

	@Override
	public void stateChanged(ChangeEvent e) {
		for (GetSetField f : this.fields.values()) {
			f.stateChanged(e);
		}
	}

}
